function [Results,Results_summary] = FitParametricDistributions(INPUT)

Distributions = {...
    0  'Normal'; ...
    1  'Logistic'; ...
    2  'Extreme_Value'; ...
    3  'Generalized_Extreme_Value'; ...
    4  'tLocationScale'; ...
    5  'Uniform'; ...
    6  'Johnson_SU'; ...
    
    10  'Exponential'; ...
    11  'Lognormal'; ...
    12  'Loglogistic'; ...
    13  'Weibull'; ...
    14  'Rayleigh'; ...
    15  'Gamma'; ...
    16  'BirnbaumSaunders'; ...
    17  'Generalized_Pareto'; ...
    18  'Inverse_Gaussian'; ...
    19  'Nakagami'; ...
    20  'Rician'; ...
    21  'Johnson_SB'; ...
    %     22  'Johnson_SL'; ...
    23  'Truncated_normal'; ...
    
    31  'Poisson'; ...
    32  'Negative_Binomial'
    };

% INPUT.HessEstFix = 0; % available options: 0 - retained from optimization, 1 - BHHH based, 2 - numerical high-precision Jacobian based, 3 - numerical Hessian based
% INPUT.SimStats = 0; % simulate descriptive statistics of the distribution
% INPUT.Spike = 0; % allow for jump density at 0
% INPUT.Censor0 = 1; % this treats WTP < 0 as 0

if isfield(INPUT,'Results')
    Results = INPUT.Results;
else
    Results = [];
end


% searching for best fitting distributions
for i = 1:size(Distributions,1)
    
%         INPUT.Algorithm = 'search';
%         try
%             INPUT.RealMin = 0;
%             if isfield(Results,(Distributions{i,2})) && isfield(Results.(Distributions{i,2}),'beta')                
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
%                 Results.(Distributions{i,2}).RealMin = 0;
%             else
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1});
%                 Results.(Distributions{i,2}).RealMin = 0;
%             end
%         catch
%             INPUT.RealMin = 1;
%             if isfield(Results,(Distributions{i,2})) && isfield(Results.(Distributions{i,2}),'beta')
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
%                 Results.(Distributions{i,2}).RealMin = 1;
%             else
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1});
%                 Results.(Distributions{i,2}).RealMin = 1;
%             end
%             INPUT.RealMin = 0;
%         end
%         %     Results_summary0(i,1:7) = [Results.(Distributions{i,2}).ModelDiagnostics(1:5,1)',Results.(Distributions{i,2}).stats(1:2,1)']; %#ok<SAGROW>
%     
%         INPUT.Algorithm = 'interior-point';
%         try
%             INPUT.RealMin = 0;
%             if isfield(Results,(Distributions{i,2})) && isfield(Results.(Distributions{i,2}),'beta')
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
%                 Results.(Distributions{i,2}).RealMin = 0;
%             else
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1});
%                 Results.(Distributions{i,2}).RealMin = 0;
%             end
%         catch
%             INPUT.RealMin = 1;
%             if isfield(Results,(Distributions{i,2})) && isfield(Results.(Distributions{i,2}),'beta')
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
%                 Results.(Distributions{i,2}).RealMin = 1;
%             else
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1});
%                 Results.(Distributions{i,2}).RealMin = 1;
%             end
%             INPUT.RealMin = 0;
%         end
%         LL0 = -Results.(Distributions{i,2}).fval;
%         dLL = 1;
%         while dLL > 1e-6
%             try
%                 INPUT.RealMin = 0;
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
%                 Results.(Distributions{i,2}).RealMin = 0;
%             catch
%                 INPUT.RealMin = 1;
%                 Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
%                 Results.(Distributions{i,2}).RealMin = 1;
%                 INPUT.RealMin = 0;
%             end
%             LL1 = -Results.(Distributions{i,2}).fval;
%             dLL = LL0 - LL1;
%             if dLL > 0
%                 LL0 = LL1;
%             end
%         end
%         %     Results_summary1(i,1:7) = [Results.(Distributions{i,2}).ModelDiagnostics(1:5,1)',Results.(Distributions{i,2}).stats(1:2,1)']; %#ok<SAGROW>
%     
    INPUT.Algorithm = 'sqp';
    try
        INPUT.RealMin = 0;
        if isfield(Results,(Distributions{i,2})) && isfield(Results.(Distributions{i,2}),'beta')
            Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
            Results.(Distributions{i,2}).RealMin = 0;
        else
            Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1});
            Results.(Distributions{i,2}).RealMin = 0;
        end
    catch
        INPUT.RealMin = 1;
        if isfield(Results,(Distributions{i,2})) && isfield(Results.(Distributions{i,2}),'beta')
            Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
            Results.(Distributions{i,2}).RealMin = 1;
        else
            Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1});
            Results.(Distributions{i,2}).RealMin = 1;
        end
        INPUT.RealMin = 0;
    end
    LL0 = -Results.(Distributions{i,2}).fval;
    dLL = 1;
    while dLL > 1e-6
        try
            INPUT.RealMin = 0;
            Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
            Results.(Distributions{i,2}).RealMin = 0;
        catch
            INPUT.RealMin = 1;
%             save tmp1
            Results.(Distributions{i,2}) = DistFit(INPUT,Distributions{i,1},Results.(Distributions{i,2}).beta);
            Results.(Distributions{i,2}).RealMin = 1;
            INPUT.RealMin = 0;
        end
        LL1 = -Results.(Distributions{i,2}).fval;
        dLL = LL0 - LL1;
        if dLL > 0
            LL0 = LL1;
        end
    end
    Results_summary2(i,1:8) = [Results.(Distributions{i,2}).ModelDiagnostics(1:5,1)',Results.(Distributions{i,2}).stats(1:2,1)',Results.(Distributions{i,2}).RealMin]; 
end

Results.Distributions = Distributions;

Results_summary = num2cell(Results_summary2);

Results_summary = [Results.Distributions(:,2), Results_summary];
